.device ATtiny13
.INCLUDE "tn13def.inc"

.DEF temp=r16
.DEF temp1=r17
.DEF CBit=r18
.DEF SendByte=r0
.EQU TXD=4
.EQU RXD=0

.CSEG
.ORG 0
 rjmp RESET ;Reset

.ORG $02
 rjmp ExtIntReq   ;External Interrupt Request

.ORG $06
 ijmp       ;Timer/Counter0 Compare Match A

.ORG INT_VECTORS_SIZE

RESET:
;  
 ldi temp,ramend
 out SPL,temp

;  b 
 ldi temp,0b00000001
 out DDRB,temp
 sbi portb,TXD

;    PB0
 ldi temp,$01
 out PCMSK,temp
 ldi temp,$20
 out GIMSK,temp

;  
 ldi temp,$20 
 out MCUCR,temp

; T0
 ldi temp,$BA 
 out OCR0A,temp
 ldi temp,$04
 out TIMSK0,temp
 ldi temp,$02
 out TCCR0A,temp
 ldi temp,$00
 out TCCR0B,temp

;   
 ldi temp,10
 ldi r30,low(Store)*2
 ldi r31,high(Store)
 clr r27
 ldi r26,$60
 NextByte:
 lpm r0,Z+
 st x+,r0
 dec temp
 brne NextByte

;  TimerCompareA
 ldi r30,low(TimerCompareA) 
 ldi r31,high(TimerCompareA)

 ldi CBit,0
 
 sbi PORTB,RXD
 cbi DDRB,RXD
 sbi PORTB,TXD
 
 sei

 ; 
 WaitPX: 
 mov temp,SendByte
 cpi temp,$37
 brne WaitPX
 ldi temp1,$00
 out GIMSK,temp1

 ; 
 ldi temp,12
 clr r27
 ldi r26,$60
 NextByteSend:
 ld r0,x+
 rcall send
 dec temp
 brne NextByteSend
 
 Func: 
 rjmp Func

Store:
.DB $34,$02,$FF,$71,$93,$17,$00,$02,$14,$07,$00,$0F

ExtIntReq:
 sbic PINB,RXD
 reti
 ldi r30,low(Delay_Resive) 
 ldi r31,high(Delay_Resive)
 clr SendByte
 ldi temp1,$06
 out TCCR0B,temp1
 ldi temp1,$00
 out GIMSK,temp1
 reti

Send:
 ldi temp1,$06
 out TCCR0B,temp1
 sbi DDRB,TXD
 ldi r30,low(Transmite_Byte) 
 ldi r31,high(Transmite_Byte)
 WaitSend: 
 sleep 
 nop
 nop
 cpi CBit,0
 brne WaitSend
 cbi DDRB,TXD
 ret

TimerCompareA:
 nop
 nop
 reti

Resive_Byte:
 inc Cbit
 cpi Cbit,1
 breq EndFuncR
 cpi CBit,10
 brsh RBit9_10
 in temp1,PINB
 bst temp1,RXD
 bld SendByte,7
 lsr SendByte
 RBit9_10:
 cpi Cbit,12
 brsh EndResive
 EndFuncR:
 ldi r30,low(Delay_Resive) 
 ldi r31,high(Delay_Resive)  
 reti
 EndResive:
 com SendByte 
 clr CBit
 ldi temp1,$00
 out TCCR0B,temp1
 out TCNT0,temp1
 ldi r30,low(TimerCompareA) 
 ldi r31,high(TimerCompareA)
 ldi temp1,$20
 out GIMSK,temp1
 reti

Delay_Resive:
 ldi r30,low(Resive_Byte) 
 ldi r31,high(Resive_Byte)
 reti

Transmite_Byte:
 inc Cbit
 cpi Cbit,1
 brne Bit1_10
 cbi portb,TXD
 rjmp EndFunc
 Bit1_10:
 cpi CBit,10
 brsh Bit9_10
 lsr SendByte
 brcs BitSet
 cbi portb,TXD
 rjmp EndFunc
 BitSet:
 sbi portb,TXD
 rjmp EndFunc
 rjmp EndFunc
 Bit9_10:
 cpi Cbit,12
 brsh EndTransmite
 sbi portb,TXD
 EndFunc:
 ldi r30,low(Delay_Transmit) 
 ldi r31,high(Delay_Transmit)  
 reti
 EndTransmite:
 clr CBit
 ldi temp1,$00
 out TCCR0B,temp1
 out TCNT0,temp1
 ldi r30,low(TimerCompareA) 
 ldi r31,high(TimerCompareA)
 reti

Delay_Transmit:
 ldi r30,low(Transmite_Byte) 
 ldi r31,high(Transmite_Byte)
 reti



.EXIT
